#!/usr/bin/perl
use File::Basename;
use strict;
use CGI qw/:standard/;
# include config file

require "/usr/local/accounts/lib/RatsClientLib.pm";
require "/usr/local/accounts/etc/rats_internal.conf";
require "/usr/local/accounts/lib/RatsClientStyle.pm";

use vars qw(%States $page @groups $grname $gid $pass $members);
use vars qw($do $c_port $s_port $log $debug $DEBUG $pgm);
# we define the log routine for all to see right here
$log = $CONFIG::COMMAND_HOOKS{'LOG'};
# same for debug
$debug = $CONFIG::COMMAND_HOOKS{'DEBUG'};

$pgm = basename $0;

# remote call function
$do = \&RatsClientLib::send_remote_command;
$c_port=$CONFIG::CLIENT_PORT;
$s_port=$CONFIG::SERVER_PORT;


$DEBUG =0 ;
## create a new query
my $q = new CGI;


print $q->header;

my $title = $CONFIG::RATS_WEB_TITLE;

my $timeout = $CONFIG::WEB_TIMEOUT;
if ($timeout != 0) {
  print $q->start_html(-title=>$title,
		       -style=>{'src'=>$RatsStyle::StyleSheetLocation},
		       -dtd=>'-//W3C//DTD HTML 4.0 Transitional//EN',
		       -script=>"setTimeout(\"window.close(self);\", $timeout)"
		      );
  
} else {
  print $q->start_html(-title=>$title,
		       -style=>{'src'=>$RatsStyle::StyleSheetLocation},
		       -dtd=>'-//W3C//DTD HTML 4.0 Transitional//EN',
		      );
  
}
&RatsStyle::doc_frame_nomenu($title);
&RatsStyle::start_cgi();


#check kiosk mode
my $kiosk = $q->param("KIOSK");

# this gets the current state of the script
if ($CONFIG::DISPLAY_AUP) {
    $page = $q->param(".State") ||  "AUP";
} else {
    $page = $q->param(".State") ||  "Default";
}



## This allows for the many in one script. 
%States = (
	   'Accept'   => \&auth_user_screen,
	   'AUP'      => \&display_aup,
           'Default'  => \&auth_user_screen,
	   'UserPass' => \&choose_user_and_pass_screen,
	   'Upemail'  => \&set_email_screen,	 	   
	   'CreateAccount' => \&create_account,
	   'Help'     => \&help,
	   'Create'  => \&verify_user,
	   'CreateUsername' => \&create_username,
	   'SetEmail' => \&set_email,
	   'Exit' => \&auth_user_screen,
	   'Reset'=> \&auth_user_screen,
	   'Configure Password Recovery' => \&rpr_enroll,
	   'Skip' => \&rpr_enroll,
	   );




# we dispatch to the appropriate routine
if ($CONFIG::WEB_NO_SERVICE) {
    print &error($CONFIG::WEB_NO_SERVICE_MSG);
} else {
    if (exists $States{$page}) {
	$States{$page}->();
    } else {
	print "No such page";
    }
}


# Only display Back/exit in kiosk mode
if ($kiosk eq 'TRUE') {
    print 
	$q->start_form,
	back_window("Back"),
	close_window("Exit"),
	$q->end_form;

}

&RatsStyle::end_cgi();
&RatsStyle::copyright_center();
&RatsStyle::doc_end();
exit;
##### end of main


sub display_aup () {
  &RatsStyle::infobox_start();
  print $CONFIG::AUP_HTML,p,$q->start_form,to_page("Accept"), $q->end_form;
  &RatsStyle::infobox_end();
  return;
}

sub auth_user_screen ($$$$$) {
    my (@accounts, $temp_acct);
    my $display_level = $q->param('DISPLAY_LEVEL');
    if ($display_level eq "" || $display_level == 0) {
	$display_level = 1;
    }
    # figure out what options to use
    foreach $temp_acct ( keys %CONFIG::ACCOUNTS) {
	if ($CONFIG::ACCOUNTS{$temp_acct}{'web_display'} == $display_level){
	    push @accounts,$temp_acct;
	}
    }
    my ($def_acct, $def_first, $def_last, $def_ssn, $def_bday) = @_;
    $def_acct = $CONFIG::WEB_DEFAULT_ACCT unless $def_acct;
    &RatsStyle::infobox_start();
    print $CONFIG::WEB_INTRO;
    &RatsStyle::infobox_end();
    print
        &RatsStyle::h3_title('Please enter the following info'),
	$q->start_form,
	$q->table({-border=>0,}, 
		  Tr({-align=>'TOP'},
		     [
		      td(["Choose an Account type:\t", 
			 $q->popup_menu(-name=>'Account',-values=>[@accounts],-default=>$def_acct),
			  ""]),
		      td(["Firstname:\t", 
			  $q->textfield(-name=>'First', -default=>$def_first, -override=>1),
			  "e.g. John"]),
		      td(["Lastname:\t", 
			  $q->textfield(-name=>'Last', -default=>$def_last, -override=>1),
			  "e.g. Smith"]),
		      td(["SSN:\t", 
			  $q->password_field(-name=>'SSN', -default=>$def_ssn, -override=>1),
			  "9 digits, no dashes, e.g. 123456789"]),
		      td(["Birthday:\t", 
			  $q->password_field(-name=>'Bday', -default=>$def_bday, -override=>1),
			  "month day year as MMDDYYYY, e.g. 01301980"]),
		      ]
		     )
		  ),
		    $q->hidden(-name=>'Firstrun', -default=>"1"),
		      to_page("CreateAccount"),
			to_page("Help"),
			  to_page("Reset");
   
    print $q->end_form;
    print &RatsStyle::info($CONFIG::SSN_NOTICE_TXT);
    return;
}

sub create_account ($) {

    my ($first, $last, $ssn, $bday, $rats_data, $code, $iid, $rcpid, $username);
    my (@args, $account, $shell, $fs, $home, $pass, $lastchg, $minday, $maxday);
    my ($warn, $inactive, $expire, $flag, $gid, $target_host, $uid, $gcos);
    my ($old_pwent, $old_account, @data, $return, $default_gid, $file_path);
    my ($copy_host, $link_host, $real_pass, $pass_error, $realm, $result);
    my ($script_host, $default_group, $home_group, $added_new_group, %old_groups);
    my ($old_group, $current_email, $new_email, $change, @suggested_names);
    my ($email_role, $admin_input, $key, $home_gid, $perm, $soft, $hard);
    my ($bad_info, $temp_fs, $mail_fs, $real_pass, $authtype);
    my ($princ,$princ_type,$kerb_realm,$salt,$need_user,$need_pass);
    my ($kerb_token, $enigma_token,$real_fs, $real_mailfs);
    my ($old_soft, $old_hard, $timestamp, $firstrun);

    $pass = $_[0];

    $first = $q->param('First');
    $last = $q->param('Last');
    $ssn = $q->param('SSN');
    $bday = $q->param('Bday');
    $account = $q->param('Account');
    $firstrun = $q->param('Firstrun');

    
    ##make sure that the info is rational
    $bad_info = "";
    #check first name
    chomp $first; $first =~ s/^\s*//; $first =~ s/\s*$//;
    unless ($first =~ /^[A-Za-z]/) {
	$bad_info .= "Your first name was not entered in a recognizable format.<p>"; 
	$first = "";
    }
    #check last name
    chomp $last; $last =~ s/^\s*//; $last =~ s/\s*$//;
    unless ($last =~ /^[A-Za-z]/) {
	$bad_info .= "Your last name was not entered in a recognizable format.<p>";
	$last = "";
    }
    #check ssn
    chomp $ssn; $ssn =~ s/^\s*//; $ssn =~ s/\s*$//;
    unless ($ssn =~ /^\d{9}$/) {
	$bad_info .= "Your Social Security Number was not entered in the required format.<p>";
	$ssn = "";
    }
    #check bday
    chomp $bday; $bday =~ s/^\s*//; $bday =~ s/\s*$//;
    unless ($bday =~ /^\d{8}$/) {
	$bad_info .= "Your birthdate was not entered in the required format.<p>";
	$bday = "";
    }

    #if any of the data was wrong ask for resubmit
    if ($bad_info) {
	print 
	    error($CONFIG::WEB_DATA_ERROR),
	    error($bad_info);
	return &auth_user_screen($account, $first, $last, $ssn, $bday);
    }

    #verify user in database
    ($rcpid, $iid, $username) = &verify_user_by_bio($first, $last, $ssn, $bday);
    unless ($rcpid =~ /^\d+$/) {
        &$log("Failed PDB lookup for $first $last: $iid $username\n");
	print 
	    error($CONFIG::WEB_DATA_ERROR),
	    error($CONFIG::PDB_NOT_FOUND_TXT),$q->p;
	return &auth_user_screen($account, $first, $last, $ssn, $bday);;
    }

    #check roles
    unless (&check_roles($rcpid, $account)) {
        print
	    error($CONFIG::ROLE_ERR_TXT),$q->p;
	return;
    }
    

    #check campus
    unless (&check_campus($rcpid, $account)) {
	print 
	    error($CONFIG::CAMPUS_ERR_TXT),$q->p;
	return;
    }

    #check major
    unless (&check_majors($rcpid, $account)) {
	print 
	    error($CONFIG::MAJORS_ERR_TXT),$q->p;
	return;
    }



    #check roster
    unless (&check_roster($rcpid, $account)) {
        print 
	    error($CONFIG::CLASS_ERR_TXT),$q->p;
	return;
    }
    




    # read in some data from the account type
    $realm = $CONFIG::ACCOUNTS{$account}{'kerb_realm'};
    $shell = $CONFIG::ACCOUNTS{$account}{'shell'};
    $fs = $CONFIG::ACCOUNTS{$account}{'home'}{'dir'};
    $home = $fs . "/" . $username;
    $authtype = $CONFIG::ACCOUNTS{$account}{'authtype'};
    $kerb_token=$CONFIG::ACCOUNTS{$account}{'kerb_token'}||$CONFIG::KERB_TOKEN;
    $kerb_realm = $CONFIG::ACCOUNTS{$account}{'kerb_realm'};
    $enigma_token = $CONFIG::ENIGMA_TOKEN;
    $princ_type = $CONFIG::ACCOUNTS{$account}{'princ'};
    $lastchg = $CONFIG::ACCOUNTS{$account}{'shadow'}{'lastchg'};
    $minday = $CONFIG::ACCOUNTS{$account}{'shadow'}{'minday'};
    $maxday = $CONFIG::ACCOUNTS{$account}{'shadow'}{'maxday'};
    $warn = $CONFIG::ACCOUNTS{$account}{'shadow'}{'warn'};
    $inactive = $CONFIG::ACCOUNTS{$account}{'shadow'}{'inactive'};
    $expire = $CONFIG::ACCOUNTS{$account}{'shadow'}{'expire'};
    $flag = $CONFIG::ACCOUNTS{$account}{'shadow'}{'flag'};
    $default_group = $CONFIG::ACCOUNTS{$account}{'groups'}{'primary'};
    $uid = -1;
    $gcos = "$first $last";
    $target_host = $CONFIG::MASTER_HOST;
    $need_user = 0;
    $need_pass = 0;



    # check if user needs username or password
    if ($username eq "") {
	$need_user = 1;
    } else {
      if ($firstrun) {
	print info("You have had an account or NetID on the Rutgers System previously. Your account name is: $username"),p;
      }
    }
    
    #check if account already exists
    $old_account = 0;
    $old_pwent = &$do('GETPWENT', $username, $target_host,$c_port);
    ($code, @data) = split (":", $old_pwent);
    if ($code == $CONFIG::API{'R_GETPWENT'}) {
	$old_account = 1;
	($username,$pass,$uid,$gid,$gcos,$home,$shell,$timestamp) = @data;
    } else {
	
	# check if using a user defined string
	if ($authtype =~ /^string=/i) {
	    $real_pass = $authtype;
	    $real_pass =~ s/^string=//i;
	# check if we need a password for crypt
	} elsif ($authtype eq "crypt") { 
	    if ($pass eq "") {
		$need_pass = 1;
	    } else {
		$salt = substr $username, 0, 2;
		$real_pass = crypt($pass, $salt);    
	    }



	# check if we need a password for kerb    
	} elsif ($authtype eq "kerberos") {
	    if ($princ_type eq "iid") {
		$real_pass = $kerb_token . $iid;
		$princ = "+$iid+";
		$princ = uc $princ;
	    } elsif ($princ_type eq "username") {
		$real_pass = $kerb_token . $username;
		$princ = $username;
	    } else {
		print error("Unknown principle type: $princ_type\n"),p;
		print error("Please contact your system administrator.\n"),p;
		return;
	    }
	    #check if user already has kerb set for this realm
	    if  (&kerb_exists($princ,$kerb_realm)) {
	      if ($firstrun) {
		print info("You already have a password set for this host."),p;
		print info("If you do not remember your password please contact the help desk."),p;
	      }
	    } else {
		if ($pass eq "") {
		    $need_pass = 1;
                # try to set kerberos
		} else {
		    unless (&set_kerb($princ, $kerb_realm, $pass)) {
			print error("Failed to set password!\n"),p;
			return;
		    }
		}
	    }


	# see if we are doing enigma    
	} elsif ($authtype eq "enigma") {
	    if ($princ_type eq "iid") {
		$real_pass = $enigma_token . $iid;
	    }elsif ($princ_type eq "username") {
		$real_pass = $enigma_token . $username;
	    }else {
		print error("Unknown principle type: $princ_type\n"),p;
		print error("Please contact your system administrator.\n"),p;
		return;
	    }
	} else {
	    print error("Unknown auth type: $authtype\n"),p;
	    print error("Please contact your system administrator.\n"),p;
	    return;
	}
	
    }

    if ($need_pass || $need_user) {
	return &create_username_pass_screen($rcpid, $last, $first, $ssn, $bday, $iid, $account, $need_pass, $need_user, $username);
    }

    
    #RPR settings. check if enrolled and allowed then set. 
    if ($CONFIG::ENABLE_RPR) {
	if (!&rpr_enrolled($username)) {
	    if (&rpr_allowed($username)) {
		return &create_rpr_data_screen($rcpid, $last, $first, $ssn, $bday, $iid, $account, $username);
	    }
	} else {
	    print &info("Your Remote Password Recovery information is configured.</p>");
	}
    }



    #get gid for the default group 
    $result = &$do('GETGID', $default_group, $target_host,$c_port);
    ($code, @data) = split (":", $result);
    if ($code == $CONFIG::API{'R_GETGID'}) {
	$default_gid = $data[0];
    } else {
	print error("Could Not Obtain GID For Primary Group $default_group\n"),p;
	return;
    }


    # try creating passwd entry unless it already exits
    unless ($old_account) {
	@args = ($username,$real_pass,$uid,$default_gid,$gcos,$home,$shell,$lastchg,$minday,$maxday,$warn,$inactive,$expire,$flag);    
	$result = &$do('ADDPWEN', @args, $target_host, $c_port);
	($code, @data) = split(":", $result);
	unless ($code == $CONFIG::API{'R_ADDPWEN'}) {
	    print error("Failed to create passwd entry: @data\n"),p;
	    return;
	} else {
	    $uid = $data[0];
	}
    }

    
    # first get the current groups if an old account 
    if ($old_account) {
	$result = &$do('GETGROUP', $username, $target_host,$c_port);
	($code, @data) = split(":", $result);
	unless ($code == $CONFIG::API{'R_GETGROUP'}) {
	    print error("Failed to get old groups: @data"),p;
	    return;
	}
	foreach $old_group (@data) {
	    $old_groups{$old_group} =1 ;
	}
    }


    # if the default gid for this account does not match the one on the existing
    # account we should add the user to the appropriate group
    $added_new_group=0;
    if ($old_account && $gid != $default_gid && $old_groups{$default_group}) {
	$result = &$do('ADDTOGRP', $username, $default_group, $target_host,$c_port);
	($code, @data) =  split(":", $result);
	unless ($code  == $CONFIG::API{'R_ADDTOGRP'}) {
	    print error("Failed to add user $username to group $default_group: @data\n"),p;
	    return;
	}
	$added_new_group=1;
    }
    
    ### add to extra groups
    # now add user the groups which (s)he was not already in 
    foreach $key (@{$CONFIG::ACCOUNTS{$account}{'groups'}{'secondary'}}) {
	$result = &$do('ADDTOGRP', $username, $key, $target_host,$c_port);
	($code, @data) =  split(":", $result);
	unless ($code  == $CONFIG::API{'R_ADDTOGRP'}) {
	    print error("Failed to add user $username to group $key: @data\n"),p;
	    return;
	}
	$added_new_group =1 ;
    }

    ### create home dir
    if ($CONFIG::ACCOUNTS{$account}{'home'}{'create'}) {
	$home_group = $CONFIG::ACCOUNTS{$account}{'home'}{'group'};
	#get gid for the home group 
	$result = &$do('GETGID',$home_group,$target_host,$c_port);
	($code, @data) = split (":", $result);
	if ($code == $CONFIG::API{'R_GETGID'}) {
	    $home_gid = $data[0];
	} else {
	    print error("Could Not Obtain GID For Home Group $home_group\n"),p;
	    return;
	}
	$perm = $CONFIG::ACCOUNTS{$account}{'home'}{'perm'};
	$result = &$do('MKDIR', $uid, $home_gid, $home, $perm, $target_host,$c_port);
	($code, @data) = split(":", $result);
	unless ($code == $CONFIG::API{'R_MKDIR'}) {
	    print error("Failed to create home directory for $username: @data\n"),p;
	    return;
	}

	# copy in startup files, if the account is new
	$copy_host = $CONFIG::ACCOUNTS{$account}{'copy'}{'host'};
	foreach $key (keys %{$CONFIG::ACCOUNTS{$account}{'copy'}{'files'}}) {
	    $file_path = $home . '/' . $CONFIG::ACCOUNTS{$account}{'copy'}{'files'}{$key};
	    $result=&$do('COPY',$key,$file_path,$uid,$home_gid,$copy_host,$c_port);
	    ($code, @data) = split (":", $result);
	    unless ($code == $CONFIG::API{'R_COPY'}) {
		print error("Failed to copy $key to $file_path: @data\n"),p;
		return;
	    }
	}
	
	# link in files
	$link_host = $CONFIG::ACCOUNTS{$account}{'link'}{'host'};
	foreach $key (keys %{$CONFIG::ACCOUNTS{$account}{'link'}{'files'}}) {
	    $file_path = $home . '/' . $CONFIG::ACCOUNTS{$account}{'link'}{'files'}{$key};
	    $result=&$do('LINK',$key,$file_path,$uid,$home_gid,$link_host,$c_port);
	    ($code, @data) = split (":", $result);
	    unless ($code == $CONFIG::API{'R_LINK'}) {
		print error("Failed to link $key to $file_path: @data\n"),p;
		return;
	    }
	}

    }
    

    # set quota on home dir. If user already existed then check 
    # the current quota and add to it.
    $soft = $CONFIG::ACCOUNTS{$account}{'home'}{'soft'};
    $hard = $CONFIG::ACCOUNTS{$account}{'home'}{'hard'};
    unless ($soft < 0 || $hard < 0) {
	$old_soft = 0;
	$old_hard = 0;
	
	# get the old quotas
	if ($old_account) {
	    $result = &$do('QGET',$uid,$home,$target_host,$c_port);
	    ($code, @data) = split (":", $result);
	    if ($code == $CONFIG::API{'R_QGET'} ) {
		$old_soft = $data[0];
		$old_hard = $data[1];
	    } else {
		&$log("Failed to get current quotas for $username/$home: @data, assuming 0's"),p;
		$old_soft = 0;
		$old_hard = 0;
	    }
	}
	# check if anything was added
	if ($added_new_group) {
	    $soft = $soft + $old_soft;
	    $hard = $hard + $old_hard;
	}
	# reset quotas if necessary
	if ($old_soft != $soft || $old_hard != $hard ) {
	    $real_fs = &RatsClientLib::determine_fs($home);
	    $result = &$do('QSET',$uid,$soft,$hard,$real_fs,$target_host,$c_port);
	    ($code, @data) = split (":", $result);
	    unless ($code==$CONFIG::API{'R_QSET'}) {
	      unless ($CONFIG::SILENT_QUOTAS) {
		print error("Failed to set quotas for $username on $fs: @data\n"),p;
	      }
	    }
	  }
	
      }
    
    # set quotas on mail 
    $mail_fs = $CONFIG::ACCOUNTS{$account}{'mail'}{'dir'};
    $soft = $CONFIG::ACCOUNTS{$account}{'mail'}{'soft'};
    $hard = $CONFIG::ACCOUNTS{$account}{'mail'}{'hard'};
    unless ($mail_fs eq "" || $soft < 0 || $hard < 0) {
	$old_soft = 0;
	$old_hard = 0;
	# get the old quotas
	if ($old_account) {
	    $result = &$do('QGET',$uid,$mail_fs,$target_host,$c_port);
	    ($code, @data) = split (":", $result);
	    if ($code == $CONFIG::API{'R_QGET'} ) {
		$old_soft = $data[0];
		$old_hard = $data[1];
	    } else {
		&$log("Failed to get current quotas for $username/$mail_fs: @data, assuming 0's"),p;
		$old_soft = 0;
		$old_hard = 0;
	    }
	}
	# reset quotas if necessary
	if ($old_soft != $soft || $old_hard != $hard ) {
	    $result = &$do('QSET',$uid,$soft,$hard,$mail_fs,$target_host,$c_port);
	    ($code, @data) = split (":", $result);
	    unless ($code==$CONFIG::API{'R_QSET'}) {
	      unless ($CONFIG::SILENT_QUOTAS) {
		print error("Failed to set quotas for $username on $mail_fs: @data\n"),p;
	      }
	    }
	  }
      }
    
    
    # set quotas elsewhere unless the account is old
    if ($CONFIG::ACCOUNTS{$account}{'set_other_q'}) {
      $real_fs = &RatsClientLib::determine_fs($home);
      $real_mailfs = &RatsClientLib::determine_fs($mail_fs);
      foreach $temp_fs (keys %CONFIG::FS) {
	unless ($temp_fs eq $real_fs || $temp_fs eq $real_mailfs) {
	  $result = &$do('QSET',$uid,1,1,$temp_fs,$target_host,$c_port);
	  ($code, @data) = split (":", $result);
	  unless ($code==$CONFIG::API{'R_QSET'}) {
	    &$log("Failed to set quotas $username $temp_fs: @data\n");
	  }
	}
      }
    }

    ### add account type to the user
    $result = &$do('ADDACCT',$username,$account,$target_host,$c_port);
    ($code, @data) = split (":", $result);
    unless ($code == $CONFIG::API{'R_ADDACCT'} ) {
	print error("Failed to set account type $account for $username: @data\n"),p;
	exit 1;
    }



    ### run admin defined scripts
    $script_host = $CONFIG::ACCOUNTS{$account}{'scripts'}{'script_host'};
    unless ($old_account) {
	if ($CONFIG::ACCOUNTS{$account}{'scripts'}{'once_script'}) {
	    $result = &$do('RUN',$CONFIG::ACCOUNTS{$account}{'scripts'}{'once_script'},$username,$script_host,$c_port);
	    ($code, @data) = split (":", $result);
	    unless ($code == $CONFIG::API{'R_RUN'}) {
		print error("Failed to run final script: @data\n"),p;
		return
		}
	}
	}
    if ($CONFIG::ACCOUNTS{$account}{'scripts'}{'always_script'}) {
	$result = &$do('RUN',$CONFIG::ACCOUNTS{$account}{'scripts'}{'always_script'},$username,$script_host,$c_port);
	($code, @data) = split (":", $result);
	unless ($code == $CONFIG::API{'R_RUN'}) {
	    print error("Failed to run final script: @data\n"),p;
	    return;
	}    
    }
    # set up email address
    
    if ($CONFIG::WEB_END_MSG) {
	print info($CONFIG::WEB_END_MSG),p;
    } else {
	print info("Account created succesfully!\n"),p;
    }

    #update email address in PDB if need be
    if ($CONFIG::ACCOUNTS{$account}{'update_email'}) {
	$current_email="";
	$new_email = "$username\@$CONFIG::EMAIL_HOST";
	$email_role = $CONFIG::ACCOUNTS{$account}{'email_role'};
	$result = &$do('GETEMAIL', $rcpid, $email_role, $CONFIG::RATS_MASTER,$s_port);
	($code, @data) = split (":", $result);
	if ($code == $CONFIG::API{'RETEMAIL'}) {
	    unless ($data[0] =~ /^\s*$/ ) {
		$current_email = $data[0];
	    }
	}

	if ($current_email eq "") {
	    $result = &$do('SETEMAIL', $rcpid, $new_email, $email_role, $CONFIG::RATS_MASTER,$s_port);
            ($code, @data) = split (":", $result);
            unless ($code == $CONFIG::API{'RETSEMAIL'}) {
                print error("Failed to set email to $new_email: @data\n"),p;
            }       
	    $current_email = $new_email;
        } 

	if ($CONFIG::ALLOW_RANDOM_EMAIL) {
	  return &ask_user_email_change_with_input($current_email, $new_email, $rcpid, $email_role);
	} else {
	  if (uc($current_email) ne uc($new_email)) {
	    return &ask_user_email_change($current_email, $new_email, $rcpid, $email_role);
	  } 
	}
      }
    return;
  }


    


sub to_page ($) {
    my ($val) = @_[0];
    my $kq = $q->hidden(-name=>'KIOSK', -default=>$kiosk);
    return $kq . &RatsStyle::to_page($q,$val);

}

# this routine take user demographics and
# turns them into rpcid, iid
sub verify_user_by_bio ($$$$) {
    my ($first, $last, $ssn, $bday) = @_;
    my $username = "";
    my (@data, $result, $error);
    #lookup user in the database
    my @args = ($first, $last, $ssn, $bday);
    my $rats_data = &$do('GETIR_FLSB',@args,$CONFIG::RATS_MASTER,$s_port);
    my ($code, @data) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETIR_FLSB'}) {
	$error = join(" ", @data);
	return ("ERROR", $error);
    } 
    my $iid = $data[0];
    my $rcpid = $data[1];
    #get username
    $result = &$do('GETUSRINF',$rcpid,$CONFIG::RATS_MASTER,$s_port);
    ($code,@data) = split (":", $result);
    if ($code == $CONFIG::API{'RETUSRINF'}) {
	$username = $data[0];
    } 
    my @return = ($rcpid, $iid, $username);
    return @return;
}

# check if a given rcpid has all the roles required by
# the account type. Take RCPID and ACCOUNT and return 0 or 1;
sub check_roles($$) {
    my ($role, $rats_data, $code, @data, $matched_one_role);
    my ($rcpid, $account) = @_;

    # first the must have ones
    foreach $role (@{$CONFIG::ACCOUNTS{$account}{'req_role'}{'all'}}) {
	$rats_data = &$do('GETROLE',$rcpid,$role,$CONFIG::RATS_MASTER,$s_port);
	($code,@data) = split (":", $rats_data);
	unless ($code == $CONFIG::API{'RETROLE'}) {
	    &$log("Failed lookup for role for $rcpid : @data\n");
	    print error("Error Retriving Roles Data: @data\n"),p;
	    return 0;
	}
	unless ($data[0]) {
	    return 0;
	}
    }

    # and now we check the must have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'req_role'}{'some'}}) == 0) {
	$matched_one_role = 0;
	foreach $role (@{$CONFIG::ACCOUNTS{$account}{'req_role'}{'some'}}) {
	    $rats_data = &$do('GETROLE',$rcpid,$role,$CONFIG::RATS_MASTER,$s_port);
	    ($code,@data) = split (":", $rats_data);
	    unless ($code == $CONFIG::API{'RETROLE'}) {
		&$log("Failed lookup for role for $rcpid : @data\n");
		print error("Error Retriving Roles Data: @data\n"),p;
		return 0 ;
	    }
	    if ($data[0]) {
		$matched_one_role = 1;
	    }
	}
	unless ($matched_one_role) {
	    return 0;
	}
    }

    # and now we check the must not have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'req_role'}{'not'}}) == 0) {
	$matched_one_role = 0;
	foreach $role (@{$CONFIG::ACCOUNTS{$account}{'req_role'}{'not'}}) {
	    $rats_data = &$do('GETROLE',$rcpid,$role,$CONFIG::RATS_MASTER,$s_port);
	    ($code,@data) = split (":", $rats_data);
	    unless ($code == $CONFIG::API{'RETROLE'}) {
		&$log("Failed lookup for role for $rcpid : @data\n");
		print error("Error Retriving Roles Data: @data\n"),p;
		return 0 ;
	    }
	    if ($data[0]) {
		$matched_one_role = 1;
	    }
	}
	if ($matched_one_role) {
	    return 0;
	}
    }
    return 1;
}
# this function takes ssn and account and check to see
# if ssn is in all the classes required by account.
# it returns 0 or 1
sub check_roster ($$) {
    my ($term, $year, $class, $rats_data, $code, @data, $matched_one_class);
    my ($rcpid, $account) = @_;
    my ($call, $r_call);

    #check roster
    # first the must have ones
    $term = $CONFIG::ACCOUNTS{$account}{'roster'}{'term'};
    $year = $CONFIG::ACCOUNTS{$account}{'roster'}{'year'};
    foreach $class (@{$CONFIG::ACCOUNTS{$account}{'roster'}{'all'}}) {
	if ($class =~ /:/) {
	    $call = 'ISINCLASS';
	    $r_call = $CONFIG::API{'R_ISINCLASS'};
	} else {
	    $call = 'ISINROSTER';
	    $r_call = $CONFIG::API{'R_ISINROSTER'};
	}
	$rats_data = &$do($call,$rcpid,$term,$year,$class,$CONFIG::RATS_MASTER,$s_port);
	($code,@data) = split (":", $rats_data);
	unless ($code eq  $r_call) {
	    &$log("Failed lookup for roster for $rcpid : @data\n");
	    print error("Error Retriving Roster Data: @data\n"),p;
	    return 0 ;
	}
	unless ($data[0]) {
	    return 0;
	}
    }
    # and now we check the must have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'roster'}{'some'}}) == 0) {
	$matched_one_class = 0;
	foreach $class (@{$CONFIG::ACCOUNTS{$account}{'roster'}{'some'}}) {
	    if ($class =~ /:/) {
		$call = 'ISINCLASS';
		$r_call = $CONFIG::API{'R_ISINCLASS'};
	    } else {
		$call = 'ISINROSTER';
		$r_call = $CONFIG::API{'R_ISINROSTER'};
	    }
	    $rats_data = &$do($call,$rcpid,$term,$year,$class,$CONFIG::RATS_MASTER,$s_port);
	    ($code,@data) = split (":", $rats_data);
	    unless ($code eq  $r_call) {
		&$log("Failed lookup for roster for $rcpid: @data\n");
		print error("Error Retriving Roster Data: @data\n"),p;
		return 0 ;
	    }
	    if ($data[0]) {
		$matched_one_class = 1;
	    }
	}
	unless ($matched_one_class) {
	    return 0
	}
    }

    # and now we check the must not have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'roster'}{'not'}}) == 0) {
	$matched_one_class = 0;
	foreach $class (@{$CONFIG::ACCOUNTS{$account}{'roster'}{'not'}}) {
	    if ($class =~ /:/) {
		$call = 'ISINCLASS';
		$r_call = $CONFIG::API{'R_ISINCLASS'};
	    } else {
		$call = 'ISINROSTER';
		$r_call = $CONFIG::API{'R_ISINROSTER'};
	    }
	    $rats_data = &$do($call,$rcpid,$term,$year,$class,$CONFIG::RATS_MASTER,$s_port);
	    ($code,@data) = split (":", $rats_data);
	    unless ($code eq  $r_call) {
		&$log("Failed lookup for roster for $rcpid: @data\n");
		print error("Error Retriving Roster Data: @data\n"),p;
		return 0 ;
	    }
	    if ($data[0]) {
		$matched_one_class = 1;
	    }
	}
	if ($matched_one_class) {
	    return 0
	}
    }


    return 1;
}

# generates 8 usernames based on the first name, last name and size of username
sub gen_names($$$) {
    my ($first, $last, $size) = @_;
    my ($offset, $chunk, $str1, $str2, $name, @list);
    my ($code, $rats_data, @data);
    $first = lc $first;
    $first =~ s/\W//g;
    $last = lc $last;
    $last =~ s/\W//g;
    $offset = 0; 
    $chunk = 0;
    while ($chunk < $size+1) {
	$str1 = substr ($first, $offset, $chunk);
	$str2 = substr ($last, $offset, $size - $chunk);
	$name = $str1 . $str2;
	$rats_data = &$do('GETUSREX',$name,$CONFIG::RATS_MASTER,$s_port);
	my ($code, @data) = split (":", $rats_data);
	unless ($code eq $CONFIG::API{'RETUSREX'}) {
	    &$log("error checking potential un $name: @data\n");
	} elsif (!$data[0]) {    # username does not already exist
	    push @list, $name;
	}
	$chunk++;
    }
    return @list
}

sub create_username_pass_screen($$$$$$$) {
    my ($rcpid, $last, $first, $ssn, $bday, $iid, $account, $need_pass, $need_user, $username) = @_;
    my (@suggested_names, $name, $password);

    print
	&RatsStyle::h3_title('Please enter the following info'),
	$q->start_form,
	$q->hidden(-name=>'Account', -default=>$account),
	$q->hidden(-name=>'First', -default=>$first),
	$q->hidden(-name=>'Last', -default=>$last),
	$q->hidden(-name=>'SSN', -default=>$ssn),
	$q->hidden(-name=>'Bday', -default=>$bday),
	$q->hidden(-name=>'RCPID', -default=>$rcpid),
	$q->hidden(-name=>'NEEDU', -default=>$need_user),
	$q->hidden(-name=>'NEEDP', -default=>$need_pass),
	$q->hidden(-name=>'IID', -default=>$iid);

    if ($need_user) {
	my @suggested_names = &gen_names($first, $last, $CONFIG::UNAME_SIZE);
	print 
	    "You do not have a username currently in use on one of our systems.", 
	    p,"We suggest one of the following, based on your name:" ,p;
	foreach $name (@suggested_names) {
	    print $name, p;
	} 
	print
	    "You may also use the \"Help\" button for other suggestions.",p,
	    &RatsStyle::h3_title('Please enter the following info:'),
	    "Enter Username:\t",
	    $q->textfield('Username')," 4 - 8 letters or digits, with a few exceptions. See help.",p;
    } else {
	print
	    "You are known to us under the following username:",p ,
	    info($username),p,
	    "That name will be reused for your new account.",p; 
    }
    if ($need_pass) {
	print 
	    "You do not have a password set. Please choose a password.",p,
	    "The password should be 6 - 8 characters, 3 character classes. See help.",p,
	    "Enter Password:\t",
	    $q->password_field('Pass1'),p
	    "Enter Password Again:\t",
	    $q->password_field('Pass2'),p;
    } else {
	print
	    info("You already have a student/facstaff account on another system. We will be reusing the password from that account."),p;

    }
    print
	to_page("CreateUsername"),
	to_page('Help');
	
    print $q->end_form;
    return;

}


sub kerb_exists($$) {
    my ($iid, $realm) = @_;
    my ($rats_data, $code, @data);
    $rats_data = &$do('GETKERB',$iid,$realm,$CONFIG::RATS_MASTER,$s_port);
    my ($code, @data) = split (":", $rats_data);
    unless ($code eq $CONFIG::API{'RETGETKERB'}) {
	&$log("error checking potential kerb for $iid: @data\n");
	print error("Failed to check if you already have a password set: @data\n"),p;
	return;
    } elsif ($data[0]) {    # username does not already exist
	return 1;
    }
    return 0;
}

sub create_username {
    my $first = $q->param('First');
    my $last = $q->param('Last');
    my $ssn = $q->param('SSN');
    my $bday = $q->param('Bday');
    my $account = $q->param('Account');
    my $username = $q->param('Username');
    my $pass1 = $q->param('Pass1');
    my $pass2 = $q->param('Pass2');
    my $rcpid = $q->param('RCPID');
    my $iid = $q->param('IID');
    my $need_user = $q->param('NEEDU');
    my $need_pass = $q->param('NEEDP');
    my $error = 0;
    my ($code, @data, $rats_data);
    $username = lc $username;
    
    my ($pass_error);

    # lets double check if a username is needed. We don't trust
    # the data give
    # We do this so a web timout does not create extra usernames.
    # If this is submited twice then the possibility of more
    # then one username becomes large.
    my $result = &$do('GETUSRINF',$rcpid,$CONFIG::RATS_MASTER,$s_port);
    ($code,@data) = split (":", $result);
    if ($code == $CONFIG::API{'RETUSRINF'} && $data[0] ne "") {
	$need_user = 0;
    } 

    # set the username 
    if ($need_user) {
	# check username format
      if ( length($username) < $CONFIG::MIN_UNAME_SIZE
	   || length($username) > $CONFIG::MAX_UNAME_SIZE
	     || $username =~ /^[a-z]{1,4}\d+$/
	     || $username =~ /\W/
	     || $username !~ /^[a-z]/
	     || $username =~ /_/) {
	    print error("Username $username does not have a valid format.\n"),p;
	    $error = 1;
	} else {
	    #check if the username is avaible
	    $rats_data = &$do('GETUSREX',$username,$CONFIG::RATS_MASTER,$s_port);
	    ($code, @data) = split (":", $rats_data);
	    unless ($code eq $CONFIG::API{'RETUSREX'}) {
		&$debug("error checking potential on $username: @data\n"),p;
		return;
	    } elsif ($data[0] == 1) {
		print error("The username you selected is already in use.\n"),p;
		$error = 1;
	    }
	}
    }

    if ($need_pass) {
	#check if the password is valid 
	if ($pass1 ne $pass2) {
	    print error("The two passwords don't match!\n"),p;
	    $error = 1;
	} else {
	    $pass_error = &check_pass($pass1);
	    unless ($pass_error eq "" ) {
		$error = 1;
		print error($pass_error),p;
	    }
	}
    }
    if ($error) {	
	return &create_username_pass_screen($rcpid,$last,$first,$ssn,$bday,$iid,$account,$need_pass,$need_user);
    }

    # set the username 
    if ($need_user) {
	$rats_data = &$do('SETACCINF',$rcpid,$username,$CONFIG::RATS_MASTER,$s_port);
	($code, @data) = split (":", $rats_data);
	unless ($code eq $CONFIG::API{'RETACCINF'}) {
	    &$debug("error checking potential un $username: @data\n");
	    print error("A fatal error accured while setting username: @data\n"),p;
	    return;
	} elsif ($data[0] == 0) {    # username does already exist
	    &$debug("error setting potential un $username: @data\n");
	    print error("The username you requested has been already allocated to a different user.\n"),p;
	    return &create_username_kerb_screen($rcpid, $last, $first, $ssn, $bday, $iid,$account,$need_pass,$need_user);
	} 
    }

    if ($need_pass) {
	return &create_account($pass1);
    } else {
    	return &create_account("");
    }
}



sub set_kerb ($$$) {
    my ($iid, $realm, $pass) = @_;
    my ($rats_data, $code, @data);
    $rats_data = &$do('SETKERB',$iid,$realm,$pass,$CONFIG::RATS_MASTER,$s_port);
    my ($code, @data) = split (":", $rats_data);
    unless ($code eq $CONFIG::API{'RETSETKERB'}) {
	&$log("error checking potential kerb for $iid: @data\n");
	print error("Failed to set your password: @data\n"),p;
	return;
    } elsif ($data[0]) {    # username does not already exist
	return 1;
    }
    return 0;
}

# checks to see if a password is easy to guess
sub check_pass ($) {
    my $pass = @_[0];
    if (length($pass) < 6 ) {
	return "Password to short.(It must be between 6 and 8 characters long.)";
    }
    if (length($pass) > 8) {
	return "Password too long (It must be between 6 and 8 characters long.)";
    }

    my $count = 0;
    if ($pass =~ /[A-Z]/) {
	$count++;
    }
    if ($pass =~ /[a-z]/) {
	$count++;
    }
    if ($pass =~ /[0-9]/) {
	$count++;
    }
    if ($pass =~ /[\W_]/) {
	$count++;
    }
    if ($pass =~ /\s/) {
	return "Password is not allowed to contain blank spaces.";
    }
    if ($count < 3) {
	return "Password does not have enough character classes. (It must have at least 3 character classes.)";
    }
    return "";
}

sub ask_user_email_change () {
    my ($current, $new, $rcpid, $email_role) = @_;
    print 
        "Your current email address is set to",
        info($current),$q->p,
        "Rutgers maintains a database used in finding people",
        "at the university. Please choose which address you want",
        "to be displayed in your database entry.";
    print
        $q->start_form,
	$q->hidden(-name=>'RCPID', -default=>$rcpid),
	$q->hidden(-name=>'ROLE', -default=>$email_role),
	$q->hidden(-name=>'OLD', -default=>$current),
	$q->hidden(-name=>'NEW', -default=>$new),
        $q->popup_menu(-name => 'email_choice',
                       -values => [$current, $new],
                       -default => $current),p,
        &to_page('SetEmail'),
        to_page('Help');

        $q->end_form;
    return;
}


sub ask_user_email_change_with_input($$$$) {
    my ($current, $new, $rcpid, $email_role) = @_;
    &RatsStyle::infobox_start();
    print 
	"Rutgers maintains a database used in finding people",
	"at the university. Included in this database is an ",
	"email address used for many automated functions, ",
	"including University announcements, class mailing lists, ",
	"and emergency contact for weather closings and other ",
	"important events. You may already have an email address ",
	"configured, but you can choose to use the email address ",
	"associated with the account you have just created, or any ",
	"other email address you may have. However, keep in mind ",
	"that if you choose an email address outside the University ",
	"we can not guarantee delivery and you may not receive ",
	"important announcements";
    &RatsStyle::infobox_end();
    if ($current) {
	print
	    "Your current email address is set to ",
	    info($current),$q->p;
    } else {
	print 
	    "Our records indicate that no email address as been ",
	    "set for you previously",$q->p;
    }
    print
	"Please enter the address you want",
	"to be displayed in your database entry. This defaults to ",
	"the new address associated with the account you have just ",
	"created. You may choose to enter the old address if one was ",
	"set or any other valid email address you may have.",$q->p;

    print
	$q->start_form,
	"Email address: ",
	$q->hidden(-name=>'RCPID', -default=>$rcpid),
	$q->hidden(-name=>'ROLE', -default=>$email_role),
	$q->hidden(-name=>'OLD', -default=>$current),
	$q->hidden(-name=>'NEW', -default=>$new),
	$q->textfield(-name => 'email_choice',
		      -override => 1,
		      -size => 56,
		      -default => $new),$q->p,
	&to_page('SetEmail'),
	to_page('Help');

	$q->end_form;
    return;
}

sub set_email {
    my $old = $q->param('OLD');
    my $new = $q->param('NEW');
    my $email = $q->param('email_choice');
    my $rcpid = $q->param('RCPID');
    my $role = $q->param('ROLE');

    if (uc($old) eq uc($email)) {
	print 
	    info("Email address left as $old\n"),p,
	    info("You are now DONE!\n"),p;
    } else {
	$email =~ s/\s//g;
	my ($uname, $host) = split('\@', $email);
	if ($host && $uname) {
	    my $h;
	    unless ($h =  gethostbyname($host)) {
		print error("The email you provided is not ".
			    "correctly formated: no hostname does not exist.");
		return ask_user_email_change_with_input($old, $new, $rcpid, $role);
	    }
	} else {
	    print error("The email you provided is not ".
			"correctly formated: no hostname provided");
	    return ask_user_email_change_with_input($old, $new, $rcpid, $role);
	}


	my $result = &$do('SETEMAIL', $rcpid, $email, $role, 
			  $CONFIG::RATS_MASTER,$s_port);
	my ($code, @data) = split (":", $result);
	unless ($code == $CONFIG::API{'RETSEMAIL'}) {
	    print error("Failed to set email to $email: @data\n"),p;
	}	    
	print 
	    info("Email address set to $email\n"),p,
	    info("You are now DONE!\n"),p;
    }
    return;
}

sub close_window () {
    my $val = shift;
    return &RatsStyle::close_window($q,$val);
}

sub back_window () {
    my $val = shift;
    return &RatsStyle::back_window($q,$val);
}
		  

# check if a given rcpid has all the campuses required by
# the account type. Take RCPID and ACCOUNT and return 0 or 1;
sub check_campus($$) {
    my ($campus, $rats_data, $code, @data, $matched_one_campus);
    my ($rcpid, $account) = @_;
    &$debug("got @_\n");
    # first the must have ones
    foreach $campus (@{$CONFIG::ACCOUNTS{$account}{'req_campus'}{'all'}}) {
	$rats_data = &$do('GETCAMPUS',$rcpid,$campus,$CONFIG::RATS_MASTER,$s_port);
	($code,@data) = split (":", $rats_data);
	unless ($code == $CONFIG::API{'RETCAMPUS'}) {
	    &$log("Failed lookup for campus for $rcpid : @data\n");
	    print error("Error Retriving Campus Data: @data\n"),p;
	    return 0;
	}
	unless ($data[0]) {
	    return 0;
	}
    }

    # and now we check the must have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'req_campus'}{'some'}}) == 0) {
	$matched_one_campus = 0;
	foreach $campus (@{$CONFIG::ACCOUNTS{$account}{'req_campus'}{'some'}}) {
	    $rats_data = &$do('GETCAMPUS',$rcpid,$campus,$CONFIG::RATS_MASTER,$s_port);
	    ($code,@data) = split (":", $rats_data);
	    unless ($code == $CONFIG::API{'RETCAMPUS'}) {
		&$log("Failed lookup for campus for $rcpid : @data\n");
		print error("Error Retriving Campus Data: @data\n"),p;
		return 0;
	    }
	    if ($data[0]) {
		$matched_one_campus = 1;
	    }
	}
	unless ($matched_one_campus) {
	    return 0;
	}
    }

    # and now we check the must not have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'req_campus'}{'not'}}) == 0) {
	$matched_one_campus = 0;
	foreach $campus (@{$CONFIG::ACCOUNTS{$account}{'req_campus'}{'not'}}) {
	    $rats_data = &$do('GETCAMPUS',$rcpid,$campus,$CONFIG::RATS_MASTER,$s_port);
	    ($code,@data) = split (":", $rats_data);
	    unless ($code == $CONFIG::API{'RETCAMPUS'}) {
		&$log("Failed lookup for campus for $rcpid : @data\n");
		print error("Error Retriving Campus Data: @data\n"),p;
		return 0;
	    }
	    if ($data[0]) {
		$matched_one_campus = 1;
	    }
	}
	if ($matched_one_campus) {
	    return 0;
	}
    }
    return 1;
}

sub help () {
  &RatsStyle::infobox_start;
  print $CONFIG::GENERAL_HELP;
  &RatsStyle::infobox_end;
  return;
}

# check if a given rcpid has all the majors required by
# the account type. Take RCPID and ACCOUNT and return 0 or 1;
sub check_majors($$) {
    my ($major, $rats_data, $code, @data, $matched_one_major);
    my ($rcpid, $account) = @_;
    &$debug("got @_\n");
    # first the must have ones
    foreach $major (@{$CONFIG::ACCOUNTS{$account}{'req_major'}{'all'}}) {
	$rats_data = &$do('GETMAJOR',$rcpid,$major,$CONFIG::RATS_MASTER,$s_port);
	($code,@data) = split (":", $rats_data);
	unless ($code == $CONFIG::API{'RETMAJOR'}) {
	    &$log("Failed lookup for major for $rcpid : @data\n");
	    print error("Error Retriving Major Data: @data\n"),p;
	    return 0 ;
	}
	unless ($data[0]) {
	    return 0;
	}
    }

    # and now we check the must have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'req_major'}{'some'}}) == 0) {
	$matched_one_major = 0;
	foreach $major (@{$CONFIG::ACCOUNTS{$account}{'req_major'}{'some'}}) {
	    $rats_data = &$do('GETMAJOR',$rcpid,$major,$CONFIG::RATS_MASTER,$s_port);
	    ($code,@data) = split (":", $rats_data);
	    unless ($code == $CONFIG::API{'RETMAJOR'}) {
		&$log("Failed lookup for major for $rcpid : @data\n");
		print error("Error Retriving Major Data: @data\n"),p;
		return 0 ;
	    }
	    if ($data[0]) {
		$matched_one_major = 1;
	    }
	}
	unless ($matched_one_major) {
	    return 0;
	}
    }

    # and now we check the must not have one of list
    unless ((scalar @{$CONFIG::ACCOUNTS{$account}{'req_major'}{'not'}}) == 0) {
	$matched_one_major = 0;
	foreach $major (@{$CONFIG::ACCOUNTS{$account}{'req_major'}{'not'}}) {
	    $rats_data = &$do('GETMAJOR',$rcpid,$major,$CONFIG::RATS_MASTER,$s_port);
            ($code,@data) = split (":", $rats_data);

	    unless ($code == $CONFIG::API{'RETMAJOR'}) {
		&$log("Failed lookup for major for $rcpid : @data\n");
		print error("Error Retriving Major Data: @data\n"),p;
		return 0 ;
	    }
	    if ($data[0]) {
		$matched_one_major = 1;
	    }
	}
	if ($matched_one_major) {
	    return 0;
	}
    }
    return 1;
}

# format error message
sub error ($) {
  return &RatsStyle::error($_[0]);
}

# format info message
sub info ($) {
  return &RatsStyle::info($_[0]);
}

#check if the user is allowed to us RPR
sub rpr_allowed() {
  my ($netid) = @_;
  my $rats_data = &$do('GETQALLOW',$netid,$CONFIG::RATS_MASTER,$s_port);
  my ($code,@data) = split (":", $rats_data);

  if ($code == $CONFIG::API{'RETQALLOW'}) {
    return $data[0];
  }

  if ($code == $CONFIG::API{'NOTFOUND'}) {
    return 1;
  }


  &$log("Failed rpr enroll lookup for $netid : @data\n");
  print error("Error Checking RPR enrollment: @data\n"),p;
  exit;
}


#check if the user is enrolled in RPR
sub rpr_enrolled() {
    my ($netid) = @_;
    my $rats_data = &$do('GETQPART',$netid,$CONFIG::RATS_MASTER,$s_port);
    my ($code,@data) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETQPART'}) {
	unless ($code == $CONFIG::API{'NOTFOUND'}) {
	    &$log("Failed lookup for RPR participation : $rats_data\n");
	    print error("Error Retriving RPR participation: $rats_data\n"),p;
	    exit;
	}
	return 0
    }
    if ($data[1] eq 'Y') {
	return 1;
    }
    return 0;

}

sub create_rpr_data_screen() {
    my ($rcpid, $last, $first, $ssn, $bday, $iid, $account, $username) = @_;
    my ($rats_data, $code, @data, @qids, $temp_qid, %current_qids);
    my $rats_data = &$do('GETVALIDQ',$CONFIG::RATS_MASTER,$s_port);
    my ($code,@qids) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETVALIDQ'}) {
	&$log("Failed lookup for RPR questions : $rats_data\n");
	print error("Error Retriving RPR information: $rats_data\n"),p;
	return 0 ;
    }
    foreach $temp_qid (@qids) {
	$rats_data = &$do('GETQTEXT',$temp_qid,$CONFIG::RATS_MASTER,$s_port);
	($code,@data) = split (":", $rats_data);
	unless ($code == $CONFIG::API{'RETQTEXT'}) {
	    &$log("Failed lookup for RPR question text for $temp_qid : @data\n");
	    print error("Error Retriving RPR information: $rats_data\n"),p;
	    return 0 ;
	}
	$current_qids{$temp_qid}=$data[0];
    }

    $current_qids{'-1'} = "- Select Question -";
    my @qid_list = keys %current_qids;

    print
	$q->start_form,
	$q->hidden(-name=>'Account', -default=>$account),
	$q->hidden(-name=>'First', -default=>$first),
	$q->hidden(-name=>'Last', -default=>$last),
	$q->hidden(-name=>'SSN', -default=>$ssn),
	$q->hidden(-name=>'Bday', -default=>$bday),
	$q->hidden(-name=>'RCPID', -default=>$rcpid),
	$q->hidden(-name=>'Username', -default=>$username),
	$q->hidden(-name=>'IID', -default=>$iid);
    &RatsStyle::infobox_start();
    print $CONFIG::RPR_ENROLL_TXT;
    &RatsStyle::infobox_end();
    print &RatsStyle::h3_title("Please fill in the following information");
    print
	$q->table({-border=>0,}, 
		  Tr({-align=>'TOP'},
		     [
		      td(["First Question:\t", 
			  $q->popup_menu(-name=>"q1",-values=>['-1',@qid_list],-default=>'-1',-labels=>\%current_qids)
			 ]),
		      td(["First Answer:\t", 
			  $q->textfield(-name=>'a1',-size=>24,-maxlength=>124)
			 ]),
		      td(["Second Question:\t", 
			  $q->popup_menu(-name=>"q2",-values=>['-1',@qid_list],-default=>'-1',-labels=>\%current_qids)
			 ]),
		      td(["Second Answer:\t", 
			  $q->textfield(-name=>'a2',-size=>24,-maxlength=>124)
			 ]),
		      td(["Third Question:\t", 
			  $q->popup_menu(-name=>"q3",-values=>['-1',@qid_list],-default=>'-1',-labels=>\%current_qids)
			 ]),
		      td(["Third Answer:\t", 
			  $q->textfield(-name=>'a3',-size=>24,-maxlength=>124)
			 ]),
		     ])),$q->br,$q->br;
    
    print
	&to_page("Configure Password Recovery"),
	&to_page("Skip");
    
    print $q->end_form;
    return;

}

sub rpr_enroll() {
    my $q1 = $q->param('q1');
    my $a1 = uc($q->param('a1'));
    my $q2 = $q->param('q2');
    my $a2 = uc($q->param('a2'));
    my $q3 = $q->param('q3');
    my $a3 = uc($q->param('a3'));

    my $first = $q->param('First');
    my $last = $q->param('Last');
    my $ssn = $q->param('SSN');
    my $bday = $q->param('Bday');
    my $account = $q->param('Account');
    my $username = $q->param('Username');
    my $pass1 = $q->param('Pass1');
    my $pass2 = $q->param('Pass2');
    my $rcpid = $q->param('RCPID');
    my $iid = $q->param('IID');
    
    my (%cq,$rats_data,$code,@data,@qids,$temp_qid);

    #verify that the user is who he says he is
    my ($rcpid1, $iid1, $username1) = &verify_user_by_bio($first, $last, $ssn, $bday);
    unless (uc($username) eq uc($username1)) {
	print "Unauthorized access detected! $username != $username1";
	&$log("SECURITY: Unauthorized access detected while setting RPR $username != $username1");
    }
    #remove all spaces and special chars. it is already upper case from above
    $a1 =~ s/^(\W|\s)$//g;
    $a2 =~ s/^(\W|\s)$//g;
    $a3 =~ s/^(\W|\s)$//g;

    $username = uc($username);

    if ($q->param(".State") eq 'Skip') {
	$rats_data = &$do('SETQUSTAT',$username,'N','Y',$CONFIG::RATS_MASTER,$s_port);
	($code,@data) = split (":", $rats_data);
	unless ($code == $CONFIG::API{'RETQUSTAT'}) {
	    &$log("Error setting opt-out  RPR data : @data\n");
	    print error("Error setting opt-out RPR data: @data\n"),p;
	    return 0 ;
	}
	return create_account("");
    }


    unless ($q1 && $q2 && $q3) {
	print error("You must select one question for each of the three securtiy ".
		    "question bellow");
	return create_rpr_data_screen();
    } 

    $rats_data = &$do('GETVALIDQ',$CONFIG::RATS_MASTER,$s_port);
    ($code,@qids) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETVALIDQ'}) {
	&$log("Failed lookup for RPR questions : $rats_data\n");
	print error("Error Retriving RPR information: $rats_data\n"),p;
	return 0 ;
    }
    foreach $temp_qid (@qids) {
	$cq{$temp_qid}=1;
    }


    unless ($cq{$q1} && $cq{$q2} && $cq{$q3}) {
	print error("Invalid question IDS selected." );
	return create_rpr_data_screen();
    } 

    if ($q1 == $q2 || $q1 == $q3 || $q2 == $q3) {
	print error("You must select three different questions. At least two of ".
		    "the questions you have selected are the same.");
	return create_rpr_data_screen();
    }
    unless ($a1 and $a2 and $a3) {
	print error("You must provide answers for all three questions. At least ".
		    "one question was missing its answer");
	return create_rpr_data_screen();
    }



    $rats_data = &$do('GETVALIDQ',$CONFIG::RATS_MASTER,$s_port);
    ($code,@qids) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETVALIDQ'}) {
    }

    # create user entry  as incomplete
    $rats_data = &$do('SETQUSTAT',$username,'Y','N',$CONFIG::RATS_MASTER,$s_port);
    ($code,@data) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETQUSTAT'}) {
	&$log("Error setting initial RPR data : @data\n");
	print error("Error setting initial RPR data: @data\n"),p;
	return 0 ;
    }


    #insert new questions
    $rats_data = &$do('SETUSERQ',$username,$q1,$a1,$CONFIG::RATS_MASTER,$s_port);
    ($code,@data) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETUSERQ'}) {
	&$log("Error setting RPR data for q1 $q1 : @data\n");
	print error("Error setting RPR data: @data\n"),p;
	return 0 ;
    }
    $rats_data = &$do('SETUSERQ',$username,$q2,$a2,$CONFIG::RATS_MASTER,$s_port);
    ($code,@data) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETUSERQ'}) {
	&$log("Error setting RPR data for q2 $q2 : @data\n");
	print error("Error setting RPR data: @data\n"),p;
	return 0 ;
    }
    $rats_data = &$do('SETUSERQ',$username,$q3,$a3,$CONFIG::RATS_MASTER,$s_port);
    ($code,@data) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETUSERQ'}) {
	&$log("Error setting RPR data for q3 $q3 : @data\n");
	print error("Error setting RPR data: @data\n"),p;
	return 0 ;
    }

    #activate
    $rats_data = &$do('SETQUSTAT',$username,'Y','Y',$CONFIG::RATS_MASTER,$s_port);
    ($code,@data) = split (":", $rats_data);
    unless ($code == $CONFIG::API{'RETQUSTAT'}) {
	&$log("Error activating RPR data : @data\n");
	print error("Error activating RPR data: @data\n"),p;
	return 0 ;
    }
    return create_account("");

}
