#!/usr/bin/perl

# This is the vipw replacement program.

use strict;
use CGI qw/:standard/;

# include rats config files
require "/usr/local/accounts/lib/RatsClientLib.pm";
require "/usr/local/accounts/etc/rats_internal.conf";
require "/usr/local/accounts/lib/RatsClientStyle.pm";


my ($do, $rats_master, $s_port, $rats_server, $c_port, $result,$code,@data);
my ($debug, $DEBUG,%States, $page, $auth_user);

# setup my 'aliases' for API calls
$do = \&RatsClientLib::send_remote_command;
$rats_master = $CONFIG::RATS_MASTER;
$s_port = $CONFIG::SERVER_PORT;
$rats_server = $CONFIG::MASTER_HOST;
$c_port = $CONFIG::CLIENT_PORT;

## the user gets set by httpd from the AUTH part
$auth_user=$ENV{REMOTE_USER};


## new CGI query
my $q = new CGI;

print $q->header();
my $title = $CONFIG::CGIPW_WEB_TITLE;
print $q->start_html(-title=>$title,
		       -style=>{'src'=>$RatsStyle::StyleSheetLocation},
		       -dtd=>'-//W3C//DTD HTML 4.0 Transitional//EN',
		      );
  
&RatsStyle::doc_frame_nomenu($title);
&RatsStyle::start_cgi();



## And if the user is not set then we quit
if ($auth_user eq "") {
    print error("Unauthenticated. Bye.");
    &RatsStyle::end_cgi();
    &RatsStyle::copyright_center();
    &RatsStyle::doc_end();
    exit -1;
}


## figure out what state we're going for
$page = $q->param(".State") || "Default";

%States = ('Default'  => \&start_screen,
	   'Main Screen' => \&start_screen,
	   'Get User List' => \&gen_user_list,
	   'Get Group List'=> \&gen_group_list,
	   'Display User' => \&display_user,
	   'Display Group'=> \&display_group,
	   'Submit User Changes'  => \&display_user,
	   'Remove From Groups' => \&display_user,
	   'Submit Group Changes' => \&display_group,
	   'Add To Groups'=> \&display_user,
	   'Remove Group' => \&remove_group,
	   'Add Group' => \&add_group,
	   'Exit'     => \&start_screen,
	   'Reset'    => \&start_screen,
	   );



# we dispatch to the appropriate routine
if ($CONFIG::WEB_NO_SERVICE) {
    print &error($CONFIG::WEB_NO_SERVICE_MSG);
} else {
    if (exists $States{$page}) {
        $States{$page}->();
    } else {
        print error("No such page");
    }
}



# this goes at the bottom of every page
print 
    $q->start_form,
    &to_page("Main Screen"),
    $q->end_form;

&RatsStyle::end_cgi();
&RatsStyle::copyright_center();
&RatsStyle::doc_end();
exit;
#####
# End of main
#####

sub start_screen() {
    print 
	$q->h1("CGIPW"),
	$q->p("Use this program to edit Users or Groups in the database. You can use wildcards when searching for usernames or groups, ? for a single character, % for many."),
	$q->hr,
	$q->startform,
        $q->hidden(-name=>'Column',
		   -value=>'uname'),
	$q->h4("Edit User:"),
	"Find users where <b>username</b>",
	" matches ",
	$q->textfield(-name=>'Username',
		      -size=>10), " ",
	to_page("Get User List"),
     	$q->endform,
	$q->hr,
	$q->h4("Edit Group:"),
	$q->startform,
	"Find groups where ",$q->b("groupname"), " matches ",
	$q->textfield(-name=>'Groupname',
		      -size=>10), " ",
	&to_page("Get Group List"),
	$q->endform,
	$q->hr,
	$q->h4("Add a Group:"),
	$q->startform,
	$q->table({-border=>0,}, 
                  Tr({-align=>'TOP'},
                     [
                      td(["Groupname:\t", 
                          $q->textfield(-name=>'gname'),
                          "e.g. sysprog"]),
                      td(["Password:\t", 
                          $q->textfield(-name=>'pass'),
                          "can be null"]),
                      td(["GID:\t", 
                          $q->textfield(-name=>'gid'),
                          "an unused GID or -1 to generate a new one"]),
                      td(["Members:\t", 
                          $q->textfield(-name=>'members'),
                          "comma separated username list"]),
                      ]
                     )
                  ),
        &to_page("Add Group"),
	$q->endform,
	$q->hr;
# ADDGRPENT


}

sub gen_user_list() {
    my ($uname, $column, $table, $u, $size);
    my $table = "password_file";

    $uname = $q->param("Username");
    $column = $q->param("Column");
    $result = &$do('SEARCH',$table,$column,$uname,$rats_server,$c_port);
    ($code,@data) = split(":",$result);
    unless ($code == $CONFIG::API{'R_SEARCH'}) {
	print &error("Failed to get user list for $uname: @data");
	return;
    }

    $size = scalar(@data);
    if ($size == 1) {
	$q->param("Username", $data[0]);
	return &display_user();
    }

    print 
	$q->h2("Matches for $uname:"),
	"<UL>\n";
    foreach $u (sort @data) {
	print "<li><A href=\"cgipw.cgi?Username=$u&Column=$column&.State=\"Display User\"\">$u</A>\n";
    }
    print "</ul>\n";

}


sub display_user() {

    my ($uname, $pass, $uid, $gid, $gcos, $home, $shell, $timestamp);
    my ($sh_uname,$shpass,$last,$min,$max,$warn,$inactive,$expire,$flag);
    my ($uname, $column);
    my ($code, @data, $username, $old_data, $old_sh_data);
    my ($status_msg, $changed);

    $username = $q->param("Username");
    $column = $q->param("Column");
    $status_msg = "";
    $changed = 0; # This is used to tell if we need to override form values
    
# If this is called for a ChgUser, we need to print the status message
# of what changes were made, otherwise it's an initial display
    if($q->param(".State") eq "Submit User Changes") {
	$status_msg = &change_user();
	$username = $q->param("username");
	$changed = 1;
    }
# similarly for RemGroups or AddGroups
    if($q->param(".State") eq "Remove From Groups") {
	$status_msg = &remove_from_groups();
	print &info($status_msg);
	return;
    }
    if($q->param(".State") eq "Add To Groups") {
	$status_msg = &add_to_groups();
	print &info($status_msg);
	return;
    }
    if($column eq "pass") {
	# if we want to allow search on other columns - nothing for now
    }
    $result = &$do('GETPWENT', $username, $rats_server, $c_port);
    ($code, @data) = split(":", $result);
    if ($code == $CONFIG::API{'R_GETPWENT'}) {
	($uname,$pass,$uid,$gid,$gcos,$home,$shell,$timestamp) =  @data;
	$old_data = join(":",@data);
    } else {
	print "Could not retrieve password entry for \"$username\": @data\n";
	exit;
    }

    $result = &$do('GETSHENT', $username, $rats_server, $c_port);
    ($code, @data) = split(":", $result);
    if($code == $CONFIG::API{'R_GETSHENT'}) {
	($sh_uname,$shpass,$last,$min,$max,$warn,$inactive,$expire,$flag) =  @data;
	$old_sh_data = join(":",@data);
    } else {
	print "Could not retrieve shadow entry for \"$username\": @data\n";
	exit;
    }

    $result = &$do('GETGROUP', $username, $rats_server, $c_port);
    ($code, @data) = split(":", $result);
    if ($code == $CONFIG::API{'R_GETGROUP'}) {
	# do nothing
    } else {
	print "Could not retrieve groups list for \"$username\": @data\n";
	exit;
    }
    my @groups = @data;
    # This ugliness is to figure out which is the primary group, because
    # REMFRGRP will not remove the primary group even though it reports
    # success.... *shrug*
    my ($g,$primary,$tmpgid,$i);
    my $g = scalar(@groups);
    for($i=0; $i<$g; $i++) {
	$result = &$do('GETGID', $groups[$i], $rats_server, $c_port);
	($code, $tmpgid) = split(":", $result);
	if($code == $CONFIG::API{'R_GETGID'}) {
	    if($tmpgid == $gid) {
		$primary = $groups[$i];
		splice(@groups,$i,1);
		last;
	    }
	} else {
	    print "Could not get GID for $g: $tmpgid<br>\n";
	    exit;
	}
    }


    my $grps = join(":",@groups);
    my @pworder = ("Username",
		   "Password",
		   "UID",
		   "GID",
		   "GCOS",
		   "Home",
		   "Shell",
		   "Last",
		   "Min",
		   "Max",
		   "Warn",
		   "Inactive",
		   "Expire",
		   "Flag");

    my %list = ("Username" => "uname:$uname",
		"Password" => "pass:$pass",
		"UID"      => "uid:$uid",
		"GID"      => "gid:$gid",
		"GCOS"     => "gcos:$gcos",
		"Home"     => "home:$home",
		"Shell"    => "shell:$shell",
		"Last"     => "last:$last",
		"Min"      => "min:$min",
		"Max"      => "max:$max",
		"Warn"     => "warn:$warn",
		"Inactive" => "inactive:$inactive",
		"Expire"   => "expire:$expire",
		"Flag"     => "flag:$flag"
		);

    $q->delete(".State");
    $q->param(-name=>"old_data",
	      -value=>"$old_data");
    $q->param(-name=>"old_sh_data",
	      -value=>"$old_sh_data");
    $q->param(-name=>"group_data",
	      -value=>"$grps");
    print 
	$q->h1("Username: $username"),
	$status_msg,
	$q->startform(),
	$q->hidden(-name=>"old_data",
		   -value=>"$old_data"),
	$q->hidden(-name=>"old_sh_data",
		   -value=>"$old_sh_data"),
	$q->hidden(-name=>"username",
		   -value=>$username),
	$q->hidden(-name=>"group_data",
		   -value=>"$grps"),
	"<table>";

    my $label;
    foreach $label (@pworder) {
	my ($field,$value) = split(':', $list{$label});
	print
	    "<tr><td>$label:</td>",
	    "<td>",$q->textfield(-name=>$field,
				 -default=>$value,
				 -override=>$changed),
	    "</td></tr>";
    }

    print
	"</table>",
	&to_page("Submit User Changes"),
	$q->endform;

    ### Group Stuff
    print
	$q->h3("Group Membership:");


    ### Print the checklist of groups the user belongs to.

    print "<b>Primary group: $primary</b> (change with GID above)<br>\n";
    $q->delete("List");    
    print
	$q->startform(),
	$q->hidden(-name=>"username",
		   -value=>$username),
	$q->hidden(-name=>"gid",
		   -value=>"$gid"),
	$q->checkbox_group(-name=>"List",
			   -values=>\@groups,
			   -linebreak=>'true'),
	&to_page("Remove From Groups"),
	$q->endform;

    ### Textbox to add groups with...
    print
	$q->startform,
	$q->hidden(-name=>"username",
		   -value=>$username),
	"Enter comma-seperated list of groups: <br>",
	$q->textfield(-name=>"groups",
 		      -value=>""),"&nbsp;",
	&to_page("Add To Groups"),
	$q->endform;
}

sub change_user() {

    my ($res, $old_data, $status, $func, $timestamp);

    my $username = $q->param("username");
    my ($uname,$pass, $uid, $gid, $gcos, $home, $shell) = ($q->param("uname"),
							   $q->param("pass"),
							   $q->param("uid"),
							   $q->param("gid"),
							   $q->param("gcos"),
							   $q->param("home"),
							   $q->param("shell"));
    my ($last,$min,$max,$warn,$inactive,$expire,
	$flag) = ($q->param("last"),
		  $q->param("min"),
		  $q->param("max"),
		  $q->param("warn"),
		  $q->param("inactive"),
		  $q->param("expire"),
		  );
    my ($o_uname,$o_pass,$o_uid,$o_gid,$o_gcos,$o_home,$o_shell,$o_timestamp);
    my ($o_sh_uname,$o_shpass,$o_last,$o_min,$o_max,$o_warn,
	$o_inactive,$o_expire,$o_flag) = split(":",$q->param("old_sh_data"));

    $old_data = $q->param("old_data");
    ($o_uname,$o_pass,$o_uid,$o_gid,$o_gcos,$o_home,$o_shell,$o_timestamp) = split(":",$old_data);
    my $grps = $q->param("group_data");
    my @groups = split(":",$grps);

    $status = sprintf("Changes to %s:<br>\n<ul>\n", $username);
    $timestamp = $o_timestamp;

    my @order = ("CHGPASSPW",
		 "CHGUID",
		 "CHGGIDPW",
		 "CHGGCOS",
		 "CHGHOME",
		 "CHGSHELL",
		 "CHGSLAST",
		 "CHGSMIN",
		 "CHGSMAX",
		 "CHGSWARN",
		 "CHGSINAC",
		 "CHGSEXP",
		 "CHGSFLAG",
		 "CHGUNAME"
		 );

    my %list = ("CHGPASSPW" => "Password:$o_pass:$pass",
		"CHGUID"    => "UID:$o_uid:$uid",
		"CHGGIDPW"  => "GID:$o_gid:$gid",
		"CHGGCOS"   => "GCOS:$o_gcos:$gcos",
		"CHGHOME"   => "Home:$o_home:$home",
		"CHGSHELL"  => "Shell:$o_shell:$shell",
		"CHGSLAST"  => "Last:$o_last:$last",
		"CHGSMIN"   => "Min:$o_min:$min",
		"CHGSMAX"   => "Max:$o_max:$max",
		"CHGSWARN"  => "Warn:$o_warn:$warn",
		"CHGSINAC"  => "Inactive:$o_inactive:$inactive",
		"CHGSEXP"   => "Expire:$o_expire:$expire",
		"CHGSFLAG"  => "Flag:$o_flag:$flag",
		"CHGUNAME"  => "Username:$o_uname:$uname"
		);


    foreach $func (@order) {
	my ($label,$oldvalue,$newvalue) = split(':',$list{$func});

	if($oldvalue ne $newvalue) {
	    $res = &do_change($func,$o_uname,$newvalue,$timestamp);
	    if($res =~ /ERROR/) {
		$status = "$status <LI>$label: $res ($timestamp)\n";
	    } else {
		$timestamp = $res;
		$status = "$status <LI>$label <b>changed</b> to '$newvalue'\n";
	    }
	    # Call scripts where needed...
	    if($func eq 'CHGUNAME') {
		$q->delete("username");
		$q->param("username","$uname");
		if($CONFIG::RENAMEU_SCRIPT) {
		    $result = &$do('RUN',$CONFIG::RENAMEU_SCRIPT,
				   $o_uname,$uname,$CONFIG::RENAMEU_SCRIPT_HOST,
				   $c_port);
		    ($code,@data) = split(":",$result);
		    unless ($code == $CONFIG::API{"R_RUN"}) {
			$status = "$status ERROR: RENAMEU_SCRIPT not run for $o_uname: @data\n";
		    }
		}
		# Remove old user from groups, add new user to groups
		my $g;
		foreach $g (@groups) {
		    $result = &$do('REMFRGRP',$o_uname,$g,$rats_server,
				   $c_port);
		    ($code,@data) = split(":",$result);
		    unless ($code == $CONFIG::API{'R_REMFRGRP'}) {
			$status = "${status}ERROR: Group Remove failed for $o_uname: @data <br>\n";
		    }
		    $result = &$do('ADDTOGRP',$uname,$g,$rats_server,$c_port);
		    ($code,@data) = split(":",$result);
		    unless ($code == $CONFIG::API{'R_ADDTOGRP'}) {
			$status = "${status}ERROR: Group Add failed for $uname: @data <br>\n";
		    }
		}
	    }
	    if($func eq 'CHGUID') {
		if($CONFIG::CHUID_SCRIPT) {
		    $result = &$do('RUN',$CONFIG::CHUID_SCRIPT,
				   $uid,$CONFIG::CHUID_SCRIPT_HOST,
				   $c_port);
		    ($code,@data) = split(":",$result);
		    unless ($code == $CONFIG::API{"R_RUN"}) {
			$status = "$status ERROR: CHUID_SCRIPT not run for $o_uname: @data\n";
		    }
		}
	    }
	} else {
	    # Do nothing
	}
    }

    $status = "$status</UL>";
    return $status;
}

sub do_change() {

   my ($func,$user,$newvalue,$timestamp) = @_;
   my ($ret);

   $result = &$do($func,$user,$newvalue,$timestamp,$rats_server,$c_port);
    ($code,@data) = split(":",$result);
    unless ($code == $CONFIG::API{"R_$func"}) {
	return "ERROR: $func failed for $user: @data\n";
    }
   $ret = $data[0];

   return $ret;
}

sub remove_from_groups() {
    my ($status, $g);
    
    my @groups = $q->param("List");
    my $uname = $q->param("username");
    $status = "";
    foreach $g (@groups) {
	$result = &$do('REMFRGRP',$uname,$g,$rats_server,$c_port);
	($code,@data) = split(":",$result);
	unless ($code == $CONFIG::API{'R_REMFRGRP'}) {
	    return "${status}ERROR: Group Remove failed for $uname: @data <br>\n";
	}
	$status = "${status}Group Removed for $uname: $g <br>\n"
    }

    return $status;
}

sub add_to_groups() {
    my ($g, $status);

    my $uname = $q->param("username");
    my $grstr = $q->param("groups");
    my @groups = split(",",$grstr);
    
    $q->delete("groups");

    foreach $g (@groups) {
	$result = &$do('ADDTOGRP',$uname,$g,$rats_server,$c_port);
	($code,@data) = split(":",$result);
	unless ($code == $CONFIG::API{'R_ADDTOGRP'}) {
	    return "${status}ERROR: Group Add failed for $uname: @data <br>\n";
	}
	$status = "${status}Group Added for $uname: $g <br>\n";
    }
    return $status;
}

sub gen_group_list() {

    my ($gname, $table, $column, $g, $size);
    
    $table = "group_file";
    $column = "gname";
    $gname = $q->param("Groupname");

    $result = &$do('SEARCH',$table,$column,$gname,$rats_server,$c_port);
    ($code,@data) = split(":",$result);
    unless ($code == $CONFIG::API{'R_SEARCH'}) {
	print &error("Failed to get group list for $gname: @data");
	return;
    }

    $size = scalar(@data);
    if ($size == 1) {
	$q->param("gname", $data[0]);
	&display_group();
	return;
    }


    print 
	$q->h2("Matches for $gname:"),
	"<UL>\n";
    foreach $g (sort @data) {
	print "<li><A href=\"cgipw.cgi?gname=$g&column=$column&.State=\"Display Group\"\">$g</A>\n";
    }
    print "</ul>\n";


}

sub display_group() {
    my ($gname,$grnam,$pass,$gid,$users,$timestamp);
    my ($status_msg, $result, $old_data, $changed);
    
    $gname = $q->param("gname");
    $status_msg = "";
    $changed = 0; # This is used to tell if we need to override form values
    
# If this is called for a ChgUser, we need to print the status message
# of what changes were made, otherwise it's an initial display
    if($q->param(".State") eq "Submit Group Changes") {
	$status_msg = &change_group();
	$changed = 1;
    }

    $result = &$do('GETGRNAM', $gname, $rats_server, $c_port);
    ($code, @data) = split(":", $result);
    if ($code == $CONFIG::API{'R_GETGRNAM'}) {
	($grnam,$pass,$gid,$users,$timestamp) =  @data;
	$old_data = join(":",@data);
    } else {
	print "Could not retrieve group entry for \"$gname\": @data\n";
	exit;
    }

    $q->delete(".State");
    $q->param(-name=>"old_data",
	      -value=>"$old_data");

    print 
	$q->h1("Groupname: $gname"),
	$status_msg,
	$q->startform(),
	$q->hidden(-name=>"old_data",
		   -value=>"$old_data"),
	$q->hidden(-name=>"gname",
		   -value=>$gname),
	"<table>",
	"<tr><td>Password:</td>",
	"<td>",$q->textfield(-name=>"pass",
			     -default=>$pass,
			     -override=>$changed),
	"</td></tr>",
	"<tr><td>GID:</td>",
	"<td>",$q->textfield(-name=>"gid",
			     -default=>$gid,
			     -override=>$changed),
	"</td></tr></table>";
    
    my @usrs = split(",",$users);

    print
	"Users: (check to remove)<br>",
	$q->checkbox_group(-name=>"users",
			   -values=>\@usrs,
			   -linebreak=>'true'),
	"<br>Comma-seperated list of users to add:<br>",
	$q->textfield(-name=>"add",
		      -default=>"",
		      -override=>"true"),"<br>",
	&to_page("Submit Group Changes"),
	$q->endform;

    print
	$q->startform,
	$q->hidden(-name=>"gname",
		   -value=>"$gname"),
	$q->hidden(-name=>"old_data",
		   -value=>"$old_data"),
	$q->textfield(-name=>"verify",
		      -size=>29,
		      -default=>"type 'yes' here and click to",
		      -override=>'true'),
	&to_page("Remove Group"),
	$q->endform;

}

sub change_group() {
    my ($gname,$pass,$gid,@users, $a, @add);
    my ($o_gname,$o_pass,$o_gid,$o_users,$timestamp);
    my ($result, $old_data, $status,$u, $res, @o_usrs);

    $gname = $q->param("gname");
    $pass = $q->param("pass");
    $gid = $q->param("gid");
    @users = $q->param("users");
    $a = $q->param("add");
    @add = split("," , $a);
    $old_data = $q->param("old_data");
    ($o_gname,$o_pass,$o_gid,$o_users,$timestamp) = split(":", $old_data);
    @o_usrs = split("," , $o_users);

    $status = "";
    if($pass ne $o_pass) {
	$res = &do_change('CHGPASSGR',$gname,$pass,$timestamp);
	if($res =~ /ERROR/) {
	    $status = "$status <LI>Pass: $res ($timestamp)\n";
	} else {
	    $timestamp = $res;
	    $status = "$status <LI>Pass <b>changed</b> to '$pass'\n";
	}
    }
    if($gid ne $o_gid) {
	# OK, this is messy... first remove all the users from the old gid.
	foreach $u (@o_usrs) {
	    $result = &$do('REMFRGRP',$u,$gname, $rats_server, $c_port);
	    ($code, @data) = split(":", $result);
	    if ($code == $CONFIG::API{'R_REMFRGRP'}) {
		# do nothing
	    } else {
		$status = "$status <LI>ERROR moving (rm) group entry for \"$u\": @data<br>\n";

	    }
	}

	# now change the gid...
	$res = &do_change('CHGGIDGR',$gname,$gid,$timestamp);
	if($res =~ /ERROR/) {
	    $status = "$status <LI>GID: $res ($timestamp)<br>\n";
	} else {
	    $timestamp = $res;
	    $status = "$status <LI>GID <b>changed</b> to '$gid'<br>\n";
	}

	# now add the users (minus selected ones) back to the new group/gid...
	foreach $u (@o_usrs) {
	    my $tmp = grep($u eq $_ , @users);
	    if($tmp > 0) {
		$status = "$status <LI>User <b>removed</b>: $u<br>\n";
		next; # Don't re-add users we just want to remove anyway...
	    }
	    $result = &$do('ADDTOGRP',$u,$gname, $rats_server, $c_port);
	    ($code, @data) = split(":", $result);
	    if ($code == $CONFIG::API{'R_ADDTOGRP'}) {
		# Do nothing.
	    } else {
		$status =  "$status <LI>ERROR moving (add) group entry for \"$u\": @data<br>\n";
	    }
	}
	# Also add new users...
	foreach $a (@add) {
	    $result = &$do('ADDTOGRP',$a,$gname, $rats_server, $c_port);
	    ($code, @data) = split(":", $result);
	    if ($code == $CONFIG::API{'R_ADDTOGRP'}) {
		$status = "$status <LI>User <b>added</b>: $a<br>\n";
	    } else {
		$status = "$status <LI>ERROR adding group entry for \"$a\": @data<br>\n";
	    }
	}
    } else { # If we didn't change the GID, we need to add/remove users...
	foreach $u (@users) {
	    $result = &$do('REMFRGRP',$u,$gname, $rats_server, $c_port);
	    ($code, @data) = split(":", $result);
	    if ($code == $CONFIG::API{'R_REMFRGRP'}) {
		$status = "$status <LI>User <b>removed</b>: $u<br>\n";
	    } else {
		$status =  "$status <LI>ERROR removing user \"$u\": @data<br>\n";
	    }   
	}
	foreach $a (@add) {
	    $result = &$do('ADDTOGRP',$a,$gname, $rats_server, $c_port);
	    ($code, @data) = split(":", $result);
	    if ($code == $CONFIG::API{'R_ADDTOGRP'}) {
		$status = "$status <LI>User <b>added</b>: $a<br>\n";
	    } else {
		$status =  "$status <LI>ERROR adding user \"$a\": @data<br>\n";
	    }  
	}
    }

    return $status;
}

sub remove_group() {
    my ($verify, $gname, $old_data, @users, $u);
    my ($o_gname,$o_pass,$o_gid,$o_users,$timestamp);

    $verify = $q->param("verify");
    if($verify ne "yes") {
	print error("You did not type 'yes' (no quotes) in the box, remove aborted.");
	return;
    }
    $gname = $q->param("gname");
    $old_data = $q->param("old_data");
    ($o_gname,$o_pass,$o_gid,$o_users,$timestamp) = split(":", $old_data);
    @users = split("," , $o_users);

    # First remove all the users...
    foreach $u (@users) {
	$result = &$do('REMFRGRP',$u,$gname, $rats_server, $c_port);
	($code, @data) = split(":", $result);
	if ($code == $CONFIG::API{'R_REMFRGRP'}) {
	    # do nothing
	} else {
	    print error("ERROR removing user '$u' from group: @data");
    	}
    }

    $result = &$do('REMGRPENT',$gname, $rats_server, $c_port);
    ($code, @data) = split(":", $result);
    if ($code == $CONFIG::API{'R_REMGRPENT'}) {
	print info("Group $gname has been removed.");
    } else {
	print error("ERROR removing group: @data");
    } 
}

sub add_group() {
    my ($gname,$pass,$gid,$members,$member,@members);

    $gname = $q->param("gname");
    $pass = $q->param("pass");
    $gid = $q->param("gid");
    $members = $q->param("members");
    chomp $members;
    chomp $gid;
    chomp $pass;
    chomp $gname;
    @members = split(",",$members);

    $result = &$do('GETGRNAM', $gname, $rats_server, $c_port);
    ($code, @data) = split(":", $result);
    if ($code == $CONFIG::API{'R_GETGRNAM'}) {
        print &error("Group $gname already exists");
	return;
    }



    $result = &$do('ADDGRPENT',$gname,$pass, $gid, $rats_server, $c_port);
    ($code, @data) = split(":", $result);
    if ($code == $CONFIG::API{'R_ADDGRPENT'}) {
	print &info("Group with GID @data[0] added.");
    } else {
	print &error("ERROR adding group: @data");
    }   
    
    foreach $member (@members) {
	$result = &$do('EXUSER', $member, $rats_server,$c_port);
	($code, @data) =  split(":", $result);
	if  ($code  == $CONFIG::API{'R_EXUSER'}) {
	    $result = &$do('ADDTOGRP',$member, $gname, $rats_server, $c_port);
	    ($code, @data) = split(":", $result);
	    if ($code == $CONFIG::API{'R_ADDTOGRP'}) {
		print &info("User $member added to $gname.");
	    } else {
		print &error("Failed to add $member to $gname: @data");
	    }   
	} else {
	    print &error("User $member is not a valid user on this host.");
	}

    }
    return;
}


sub to_page ($) {
    my $val = shift;
    return &RatsStyle::to_page($q,$val);
}
# format error message
sub error ($) {
  return &RatsStyle::error($_[0]);
}

# format info message
sub info ($) {
  return &RatsStyle::info($_[0]);
}

